#include <iostream>

class base {
  public:
    int x;
  protected:
    int y;
  private:
    int z;
};

class A : public base {
  public:
    int getx () {return base::x;}
    int gety () {return base::y;}
    //int getz() {return base::z;} // private wihin this context
};

class B : protected base {
  public:
    int getx () {return base::x;}
    int gety () {return base::y;}
    //int getz() {return base::z;} // private wihin this context
};

class C : private base {
  public:
    int getx () {return base::x;}
    int gety () {return base::y;}
    //int getz() {return base::z;} // private wihin this context
};

int main () {
  A a;
  a.x = 5;

  B b;
  //b.x = 5; // inaccessible within this context
  std::cout << b.getx() << std::endl;

  C c;
  c.getx();
};
